function fv.core.Worker.findBetterTool(w)
	local config = fv.core.config
	local gameInfo = fv.core.game.gameInfo
	local barn = nil
	local toolOptions = fv.core.Worker.toolOptions

	for i, toolOption in ipairs(toolOptions) do	
		
		if gameInfo:isResourceBlocked(toolOption) == false and gameInfo:getResourceStored(toolOption) > 0 then
		
			barn = findBarnWithRes(w, w.pos, toolOption, config.findResourcesRadius)

			if barn ~= nil then
				if barn:getResourceFree(toolOption) > 0 then
					w:addTaskSetHint("@hint_get_tool@")

					fv.core.goToBuildingOptimized(w, barn)
					w:addTaskPlayAnimation("stay")
					w:addTaskRemoveResourceFromBuilding(barn, toolOption, 1)
					w:addTaskWait(1000)
					
					local data = {}
					data["tool"] = toolOption
					w:addTaskScript("taskTakeTool", data)
					
					w:addTaskResetHint()
					
					return true;
				end
			end
		end
	end
end	